#pragma once

#include <iterator>
#include <fstream>
#include <ctime>
#include <vector>
#include <algorithm>
#include <iostream>

class ModifyFunctor {
public:
	ModifyFunctor(int p_min, int p_max) : min(p_min), max(p_max) {}
	int operator() (int& toSum) {
		toSum = toSum + (abs(min) + abs(max)) / 2;
		return 1;
	}
private:
	int min;
	int max;
};

void createData();

void createDataIter();

void modify(const std::string& p_fileName);

template<class container>
void loadData(container& cont) {
	std::ifstream In("numbers.txt");
	for (int i = 0; i < 100; i++) {
		int tmp;
		In >> tmp;
		cont.push_back(tmp);
	}
}

template<class container>
void loadDataIter(container& cont) {
	std::ifstream In("numbers.txt");
	std::istream_iterator<int> iterBegin(In);
	std::istream_iterator<int> iterEnd;
	std::copy(iterBegin, iterEnd, std::back_inserter(cont));
}

template<class container>
void modify_transform(container& cont) {
	int elemsAvg = 0;
	int elemsSum = 0;
	int maxNum = *std::max_element(cont.begin(), cont.end());
	int minNum = *std::min_element(cont.begin(), cont.end());
	ModifyFunctor sumMod(minNum, maxNum);
	std::for_each(cont.begin(), cont.end(), sumMod);
	std::for_each(cont.begin(), cont.end(), [&elemsAvg](int& toAvg) { elemsAvg = elemsAvg + abs(toAvg); });
	elemsAvg /= 100;
	std::for_each(cont.begin(), cont.end(), [&elemsAvg](int& toAvg) { elemsAvg = elemsAvg + abs(toAvg); });
	cont.push_back(elemsSum);
	cont.push_back(elemsAvg);
}

template<class Iter>
void modify(Iter beg, Iter end) {
	int maxNum = *std::max_element(beg, end);
	int minNum = *std::min_element(beg, end);
	ModifyFunctor sumMod(minNum, maxNum);
	std::for_each(beg, end, sumMod);
}

template<class container>
void outputResult(container& cont) {
	std::ofstream Out("numbers.txt");
	std::for_each(cont.begin(), cont.end(), [&Out](int& num) {Out << num << ' '; });
	Out.close();
}

template<class container>
void outputResultIter(container& cont) {
	std::ofstream Out("numbers.txt");
	std::ostream_iterator<int> Iter(Out, " ");
	std::copy(cont.begin(), cont.end(), Iter);
	Out.close();
}

template <class container>
void modify(const std::string& p_fileName) {
	container tmp(100);                  //!!!           
	std::ifstream tmpIn(p_fileName);
	std::istream_iterator<int> tmpIterBegin(tmpIn);
	std::istream_iterator<int> tmpIterEnd;
	std::copy(tmpIterBegin, tmpIterEnd, tmp.begin());
	int maxNum = *std::max_element(tmp.begin(), tmp.end());
	int minNum = *std::min_element(tmp.begin(), tmp.end());
	tmpIn.close();
	std::ifstream In(p_fileName);
	std::istream_iterator<int> iterBegin(In);
	std::istream_iterator<int> iterEnd;
	std::ofstream Out("result.txt");
	std::ostream_iterator<int> Iter(Out, " ");
	std::transform(iterBegin, iterEnd, Iter, [&minNum, &maxNum](int toSum) {return toSum + (abs(minNum) + abs(maxNum)) / 2; });
	In.close();
	Out.close();
	std::ifstream InP("result.txt");
	std::istream_iterator<int> iterBegP(InP);
	std::istream_iterator<int> iterEndP;
	std::ostream_iterator<int> OutP(std::cout, " ");
	std::copy(iterBegP, iterEndP, OutP);
	InP.close();
}

template <class container>
void createDataIter() {
	container randVec(100);
	srand(time(nullptr));    //!!! NULL   nullptr
	std::generate(randVec.begin(), randVec.end(), []() { return  rand() % 101 - 50;  });
	std::ofstream Out("numbers.txt");
	std::ostream_iterator<int> Iter(Out, " ");
	std::copy(randVec.begin(), randVec.end(), Iter);
	Out.close();
}


