#pragma once
#include "Function.h"
#include <vector>
#include <iostream>
#include <algorithm>
#include "windows.h"
class Menu {
public:
	void run()
	{
		std::vector<int> cont;
		bool state = true;
		int option;

		std::ostream_iterator<int> Out(std::cout, " ");

		while (state)
		{
			std::cout << std::endl << "1)Create data" << std::endl
				<< "2)Create data by iterators" << std::endl
				<< "3)Load data" << std::endl
				<< "4)Load data by iterators" << std::endl
				<< "5)Modify by container" << std::endl
				<< "6)Modify by container iterators" << std::endl
				<< "7)Modify by filename" << std::endl
				<< "8)Output result" << std::endl
				<< "9)Output result by iterators" << std::endl
				<< "10)Output container in console" << std::endl
				<< "11)Exit" << std::endl
				<< "-> ";


			std::cin >> option;

			std::cout << std::endl;

			switch (option)
			{
			case 1:
				std::cout << "Creating data" << std::endl;
				std::cout << ".";
				Sleep(500);
				std::cout << ".";
				Sleep(500);
				std::cout << "." << std::endl;
				createData();
				std::cout << "Data successfully created!" << std::endl;
				break;
			case 2:
				std::cout << "Creating data ";
				std::cout << ".";
				Sleep(500);
				std::cout << ".";
				Sleep(500);
				std::cout << "." << std::endl;
				createDataIter<std::vector<int>>();
				std::cout << "Data successfully created!" << std::endl;
				break;
			case 3:
				std::cout << "Loading data ";
				std::cout << ".";
				Sleep(500);
				std::cout << ".";
				Sleep(500);
				std::cout << "." << std::endl;
				loadData<std::vector<int>>(cont);
				std::cout << "Data successfully loaded!" << std::endl;
				break;
			case 4:
				std::cout << "Loading data ";
				std::cout << ".";
				Sleep(500);
				std::cout << ".";
				Sleep(500);
				std::cout << "." << std::endl;
				loadDataIter<std::vector<int>>(cont);
				std::cout << "Data successfully loaded!" << std::endl;
				break;
			case 5:
				if (cont.empty())
				{
					std::cout << "Container is empty!" << std::endl;
				}
				else
				{
					std::cout << "Container after modify: " << std::endl;
					modify_transform<std::vector<int>>(cont);
					std::copy(cont.begin(), cont.end(), Out);
				}
				break;
			case 6:
				if (cont.empty())
				{
					std::cout << "Container is empty!" << std::endl;
				}
				else
				{
					std::cout << "Container after modify: " << std::endl;
					modify(cont.begin(), cont.end());
					std::copy(cont.begin(), cont.end(), Out);
				}
				break;
			case 7:
				if (cont.empty())
				{
					std::cout << "Container is empty!" << std::endl;
				}
				else
				{
					std::cout << "File after modify: " << std::endl;
					modify<std::vector<int>>("numbers.txt");
				}
				break;
			case 8:
				if (cont.empty())
				{
					std::cout << "Container is empty!" << std::endl;
				}
				else
				{
					outputResult<std::vector<int>>(cont);
					std::cout << "Container succesfully outputed!" << std::endl;
				}
				break;
			case 9:
				if (cont.empty())
				{
					std::cout << "Container is empty!" << std::endl;
				}
				else
				{
					outputResultIter<std::vector<int>>(cont);
					std::cout << "Container succesfully outputed!" << std::endl;
				}
				break;
			case 10:
				if (cont.empty())
				{
					std::cout << "Container is empty!" << std::endl;
				}
				else
				{
					std::cout << "Container: " << std::endl;
					std::copy(cont.begin(), cont.end(), Out);
				}
				break;
			case 11:
				state = false;
				break;
			default:
				std::cout << "invalid option" << std::endl;
				break;
			}

		}

	}
};